# exec(open('pendulum.py').read())

import numpy as np
import matplotlib.pyplot as plt
from   scipy.integrate import odeint

def dxdt( x, t, gamma):
    dxdt    = np.zeros(4)
    dxdt[0] = x[2]                                            # dtheta/dt 
    dxdt[1] = x[3]                                            # dl/dt
    dxdt[2] = -2.0*x[3]/x[1]*x[2] -np.sin(x[0])/x[1]          # d2l/dt2
    dxdt[3] = x[1]*x[2]**2 -x[1]+1 + gamma*(np.cos(x[0])-1.0) # d2theta/dt2 
    return dxdt

gamma = 0.4

x = np.array([-0.6, 1.252, 0.0, 0.0])
t = 2 * np.pi * np.linspace(0.0,10.0, 10000)
s = odeint(dxdt, x, t, args=(gamma,))
plt.clf(), plt.plot(s[:,0],-s[:,1])


h = s[:,1]**2 * s[:,2]**2 +  s[:,3]**2 + ( s[:,1] - 1.0 + gamma)**2 \
  - 2.0*gamma*s[:,1]*np.cos(s[:,0])
 
# energy conservation not correct yet


# gamma=0.1, x = np.array([-0.6, 1.27, 0.0, 0.0]) # hop-mode
# gamma=0.4, x = np.array([-0.6, 1.252, 0.0, 0.0])
